#ifndef _STOCHASTICSIMULATOR_H
#define _STOCHASTICSIMULATOR_H

template<typename EVENT>
class StochasticSimulator {
public:
	virtual ~StochasticSimulator() {}
	virtual bool AddEvent(const EVENT& event) = 0;
	virtual bool EraseEvent(const EVENT& event) = 0;
	virtual bool ContainsEvent(const EVENT& event) const = 0;
	virtual bool ModifyEvent(EVENT event) = 0;
	virtual const EVENT& SampleEvent(void) = 0;
	virtual double TimeLapsed(double khatf) = 0;
};

#endif // _STOCHASTICSIMULATOR_H
